Win32: add a cache below mingw's lstat and dirent implementations
[git/mingw/4msysgit.git] / git-submodule.sh
blob48a789b70740c7a7cf1210cf7f5f539a4df9d59d
1 #!/bin/sh
3 # git-submodule.sh: add, init, update or list git submodules
5 # Copyright (c) 2007 Lars Hjemli
7 dashless=$(basename "$0" | sed -e 's/-/ /')
8 USAGE="[--quiet] add [-b <branch>] [-f|--force] [--name <name>] [--reference <repository>] [--] <repository> [<path>]
9 or: $dashless [--quiet] status [--cached] [--recursive] [--] [<path>...]
10 or: $dashless [--quiet] init [--] [<path>...]
11 or: $dashless [--quiet] deinit [-f|--force] [--] <path>...
12 or: $dashless [--quiet] update [--init] [--remote] [-N|--no-fetch] [-f|--force] [--rebase] [--reference <repository>] [--merge] [--recursive] [--] [<path>...]
13 or: $dashless [--quiet] summary [--cached|--files] [--summary-limit <n>] [commit] [--] [<path>...]
14 or: $dashless [--quiet] foreach [--recursive] <command>
15 or: $dashless [--quiet] sync [--recursive] [--] [<path>...]"
16 OPTIONS_SPEC=
17 SUBDIRECTORY_OK=Yes
18 . git-sh-setup
19 . git-sh-i18n
20 . git-parse-remote
21 require_work_tree
22 wt_prefix=$(git rev-parse --show-prefix)
23 cd_to_toplevel
25 command=
26 branch=
27 force=
28 reference=
29 cached=
30 recursive=
31 init=
32 files=
33 remote=
34 nofetch=
35 update=
36 prefix=
37 custom_name=
38 depth=
40 # The function takes at most 2 arguments. The first argument is the
41 # URL that navigates to the submodule origin repo. When relative, this URL
42 # is relative to the superproject origin URL repo. The second up_path
43 # argument, if specified, is the relative path that navigates
44 # from the submodule working tree to the superproject working tree.
46 # The output of the function is the origin URL of the submodule.
48 # The output will either be an absolute URL or filesystem path (if the
49 # superproject origin URL is an absolute URL or filesystem path,
50 # respectively) or a relative file system path (if the superproject
51 # origin URL is a relative file system path).
53 # When the output is a relative file system path, the path is either
54 # relative to the submodule working tree, if up_path is specified, or to
55 # the superproject working tree otherwise.
56 resolve_relative_url ()
58 remote=$(get_default_remote)
59 remoteurl=$(git config "remote.$remote.url") ||
60 remoteurl=$(pwd) # the repository is its own authoritative upstream
61 url="$1"
62 remoteurl=${remoteurl%/}
63 sep=/
64 up_path="$2"
66 case "$remoteurl" in
67 *:*|/*)
68 is_relative=
70 ./*|../*)
71 is_relative=t
74 is_relative=t
75 remoteurl="./$remoteurl"
77 esac
79 while test -n "$url"
81 case "$url" in
82 ../*)
83 url="${url#../}"
84 case "$remoteurl" in
85 */*)
86 remoteurl="${remoteurl%/*}"
88 *:*)
89 remoteurl="${remoteurl%:*}"
90 sep=:
93 if test -z "$is_relative" || test "." = "$remoteurl"
94 then
95 die "$(eval_gettext "cannot strip one component off url '\$remoteurl'")"
96 else
97 remoteurl=.
100 esac
102 ./*)
103 url="${url#./}"
106 break;;
107 esac
108 done
109 remoteurl="$remoteurl$sep${url%/}"
110 echo "${is_relative:+${up_path}}${remoteurl#./}"
113 # Resolve a path to be relative to another path. This is intended for
114 # converting submodule paths when git-submodule is run in a subdirectory
115 # and only handles paths where the directory separator is '/'.
117 # The output is the first argument as a path relative to the second argument,
118 # which defaults to $wt_prefix if it is omitted.
119 relative_path ()
121 local target curdir result
122 target=$1
123 curdir=${2-$wt_prefix}
124 curdir=${curdir%/}
125 result=
127 while test -n "$curdir"
129 case "$target" in
130 "$curdir/"*)
131 target=${target#"$curdir"/}
132 break
134 esac
136 result="${result}../"
137 if test "$curdir" = "${curdir%/*}"
138 then
139 curdir=
140 else
141 curdir="${curdir%/*}"
143 done
145 echo "$result$target"
149 # Get submodule info for registered submodules
150 # $@ = path to limit submodule list
152 module_list()
154 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
156 git ls-files -z --error-unmatch --stage -- "$@" ||
157 echo "unmatched pathspec exists"
159 perl -e '
160 my %unmerged = ();
161 my ($null_sha1) = ("0" x 40);
162 my @out = ();
163 my $unmatched = 0;
164 $/ = "\0";
165 while (<STDIN>) {
166 if (/^unmatched pathspec/) {
167 $unmatched = 1;
168 next;
170 chomp;
171 my ($mode, $sha1, $stage, $path) =
172 /^([0-7]+) ([0-9a-f]{40}) ([0-3])\t(.*)$/;
173 next unless $mode eq "160000";
174 if ($stage ne "0") {
175 if (!$unmerged{$path}++) {
176 push @out, "$mode $null_sha1 U\t$path\n";
178 next;
180 push @out, "$_\n";
182 if ($unmatched) {
183 print "#unmatched\n";
184 } else {
185 print for (@out);
190 die_if_unmatched ()
192 if test "$1" = "#unmatched"
193 then
194 exit 1
199 # Print a submodule configuration setting
201 # $1 = submodule name
202 # $2 = option name
203 # $3 = default value
205 # Checks in the usual git-config places first (for overrides),
206 # otherwise it falls back on .gitmodules. This allows you to
207 # distribute project-wide defaults in .gitmodules, while still
208 # customizing individual repositories if necessary. If the option is
209 # not in .gitmodules either, print a default value.
211 get_submodule_config () {
212 name="$1"
213 option="$2"
214 default="$3"
215 value=$(git config submodule."$name"."$option")
216 if test -z "$value"
217 then
218 value=$(git config -f .gitmodules submodule."$name"."$option")
220 printf '%s' "${value:-$default}"
225 # Map submodule path to submodule name
227 # $1 = path
229 module_name()
231 # Do we have "submodule.<something>.path = $1" defined in .gitmodules file?
232 sm_path="$1"
233 re=$(printf '%s\n' "$1" | sed -e 's/[].[^$\\*]/\\&/g')
234 name=$( git config -f .gitmodules --get-regexp '^submodule\..*\.path$' |
235 sed -n -e 's|^submodule\.\(.*\)\.path '"$re"'$|\1|p' )
236 test -z "$name" &&
237 die "$(eval_gettext "No submodule mapping found in .gitmodules for path '\$sm_path'")"
238 echo "$name"
242 # Clone a submodule
244 # Prior to calling, cmd_update checks that a possibly existing
245 # path is not a git repository.
246 # Likewise, cmd_add checks that path does not exist at all,
247 # since it is the location of a new submodule.
249 module_clone()
251 sm_path=$1
252 name=$2
253 url=$3
254 reference="$4"
255 depth="$5"
256 quiet=
257 if test -n "$GIT_QUIET"
258 then
259 quiet=-q
262 gitdir=
263 gitdir_base=
264 base_name=$(dirname "$name")
266 gitdir=$(git rev-parse --git-dir)
267 gitdir_base="$gitdir/modules/$base_name"
268 gitdir="$gitdir/modules/$name"
270 if test -d "$gitdir"
271 then
272 mkdir -p "$sm_path"
273 rm -f "$gitdir/index"
274 else
275 mkdir -p "$gitdir_base"
277 clear_local_git_env
278 git clone $quiet ${depth:+"$depth"} -n ${reference:+"$reference"} \
279 --separate-git-dir "$gitdir" "$url" "$sm_path"
280 ) ||
281 die "$(eval_gettext "Clone of '\$url' into submodule path '\$sm_path' failed")"
284 # We already are at the root of the work tree but cd_to_toplevel will
285 # resolve any symlinks that might be present in $PWD
286 a=$(cd_to_toplevel && cd "$gitdir" && pwd)/
287 b=$(cd_to_toplevel && cd "$sm_path" && pwd)/
288 # Remove all common leading directories after a sanity check
289 if test "${a#$b}" != "$a" || test "${b#$a}" != "$b"; then
290 die "$(eval_gettext "Gitdir '\$a' is part of the submodule path '\$b' or vice versa")"
292 while test "${a%%/*}" = "${b%%/*}"
294 a=${a#*/}
295 b=${b#*/}
296 done
297 # Now chop off the trailing '/'s that were added in the beginning
298 a=${a%/}
299 b=${b%/}
301 # Turn each leading "*/" component into "../"
302 rel=$(echo $b | sed -e 's|[^/][^/]*|..|g')
303 echo "gitdir: $rel/$a" >"$sm_path/.git"
305 rel=$(echo $a | sed -e 's|[^/][^/]*|..|g')
306 (clear_local_git_env; cd "$sm_path" && GIT_WORK_TREE=. git config core.worktree "$rel/$b")
309 isnumber()
311 n=$(($1 + 0)) 2>/dev/null && test "$n" = "$1"
315 # Add a new submodule to the working tree, .gitmodules and the index
317 # $@ = repo path
319 # optional branch is stored in global branch variable
321 cmd_add()
323 # parse $args after "submodule ... add".
324 reference_path=
325 while test $# -ne 0
327 case "$1" in
328 -b | --branch)
329 case "$2" in '') usage ;; esac
330 branch=$2
331 shift
333 -f | --force)
334 force=$1
336 -q|--quiet)
337 GIT_QUIET=1
339 --reference)
340 case "$2" in '') usage ;; esac
341 reference_path=$2
342 shift
344 --reference=*)
345 reference_path="${1#--reference=}"
347 --name)
348 case "$2" in '') usage ;; esac
349 custom_name=$2
350 shift
352 --depth)
353 case "$2" in '') usage ;; esac
354 depth="--depth=$2"
355 shift
357 --depth=*)
358 depth=$1
361 shift
362 break
365 usage
368 break
370 esac
371 shift
372 done
374 if test -n "$reference_path"
375 then
376 is_absolute_path "$reference_path" ||
377 reference_path="$wt_prefix$reference_path"
379 reference="--reference=$reference_path"
382 repo=$1
383 sm_path=$2
385 if test -z "$sm_path"; then
386 sm_path=$(echo "$repo" |
387 sed -e 's|/$||' -e 's|:*/*\.git$||' -e 's|.*[/:]||g')
390 if test -z "$repo" -o -z "$sm_path"; then
391 usage
394 is_absolute_path "$sm_path" || sm_path="$wt_prefix$sm_path"
396 # assure repo is absolute or relative to parent
397 case "$repo" in
398 ./*|../*)
399 test -z "$wt_prefix" ||
400 die "$(gettext "Relative path can only be used from the toplevel of the working tree")"
402 # dereference source url relative to parent's url
403 realrepo=$(resolve_relative_url "$repo") || exit
405 *:*|/*)
406 # absolute url
407 realrepo=$repo
410 die "$(eval_gettext "repo URL: '\$repo' must be absolute or begin with ./|../")"
412 esac
414 # normalize path:
415 # multiple //; leading ./; /./; /../; trailing /
416 sm_path=$(printf '%s/\n' "$sm_path" |
417 sed -e '
418 s|//*|/|g
419 s|^\(\./\)*||
420 s|/\./|/|g
421 :start
422 s|\([^/]*\)/\.\./||
423 tstart
424 s|/*$||
426 git ls-files --error-unmatch "$sm_path" > /dev/null 2>&1 &&
427 die "$(eval_gettext "'\$sm_path' already exists in the index")"
429 if test -z "$force" && ! git add --dry-run --ignore-missing "$sm_path" > /dev/null 2>&1
430 then
431 cat >&2 <<EOF
432 The following path is ignored by one of your .gitignore files:
433 $(eval_gettextln $sm_path)
434 Use -f if you really want to add it.
436 exit 1
439 if test -n "$custom_name"
440 then
441 sm_name="$custom_name"
442 else
443 sm_name="$sm_path"
446 # perhaps the path exists and is already a git repo, else clone it
447 if test -e "$sm_path"
448 then
449 if test -d "$sm_path"/.git -o -f "$sm_path"/.git
450 then
451 eval_gettextln "Adding existing repo at '\$sm_path' to the index"
452 else
453 die "$(eval_gettext "'\$sm_path' already exists and is not a valid git repo")"
456 else
457 if test -d ".git/modules/$sm_name"
458 then
459 if test -z "$force"
460 then
461 echo >&2 "$(eval_gettext "A git directory for '\$sm_name' is found locally with remote(s):")"
462 GIT_DIR=".git/modules/$sm_name" GIT_WORK_TREE=. git remote -v | grep '(fetch)' | sed -e s,^," ", -e s,' (fetch)',, >&2
463 echo >&2 "$(eval_gettext "If you want to reuse this local git directory instead of cloning again from")"
464 echo >&2 " $realrepo"
465 echo >&2 "$(eval_gettext "use the '--force' option. If the local git directory is not the correct repo")"
466 die "$(eval_gettext "or you are unsure what this means choose another name with the '--name' option.")"
467 else
468 echo "$(eval_gettext "Reactivating local git directory for submodule '\$sm_name'.")"
471 module_clone "$sm_path" "$sm_name" "$realrepo" "$reference" "$depth" || exit
473 clear_local_git_env
474 cd "$sm_path" &&
475 # ash fails to wordsplit ${branch:+-b "$branch"...}
476 case "$branch" in
477 '') git checkout -f -q ;;
478 ?*) git checkout -f -q -B "$branch" "origin/$branch" ;;
479 esac
480 ) || die "$(eval_gettext "Unable to checkout submodule '\$sm_path'")"
482 git config submodule."$sm_name".url "$realrepo"
484 git add $force "$sm_path" ||
485 die "$(eval_gettext "Failed to add submodule '\$sm_path'")"
487 git config -f .gitmodules submodule."$sm_name".path "$sm_path" &&
488 git config -f .gitmodules submodule."$sm_name".url "$repo" &&
489 if test -n "$branch"
490 then
491 git config -f .gitmodules submodule."$sm_name".branch "$branch"
492 fi &&
493 git add --force .gitmodules ||
494 die "$(eval_gettext "Failed to register submodule '\$sm_path'")"
498 # Execute an arbitrary command sequence in each checked out
499 # submodule
501 # $@ = command to execute
503 cmd_foreach()
505 # parse $args after "submodule ... foreach".
506 while test $# -ne 0
508 case "$1" in
509 -q|--quiet)
510 GIT_QUIET=1
512 --recursive)
513 recursive=1
516 usage
519 break
521 esac
522 shift
523 done
525 toplevel=$(pwd)
527 # dup stdin so that it can be restored when running the external
528 # command in the subshell (and a recursive call to this function)
529 exec 3<&0
531 module_list |
532 while read mode sha1 stage sm_path
534 die_if_unmatched "$mode"
535 if test -e "$sm_path"/.git
536 then
537 displaypath=$(relative_path "$sm_path")
538 say "$(eval_gettext "Entering '\$prefix\$displaypath'")"
539 name=$(module_name "$sm_path")
541 prefix="$prefix$sm_path/"
542 clear_local_git_env
543 cd "$sm_path" &&
544 sm_path=$(relative_path "$sm_path") &&
545 # we make $path available to scripts ...
546 path=$sm_path &&
547 eval "$@" &&
548 if test -n "$recursive"
549 then
550 cmd_foreach "--recursive" "$@"
552 ) <&3 3<&- ||
553 die "$(eval_gettext "Stopping at '\$prefix\$displaypath'; script returned non-zero status.")"
555 done
559 # Register submodules in .git/config
561 # $@ = requested paths (default to all)
563 cmd_init()
565 # parse $args after "submodule ... init".
566 while test $# -ne 0
568 case "$1" in
569 -q|--quiet)
570 GIT_QUIET=1
573 shift
574 break
577 usage
580 break
582 esac
583 shift
584 done
586 module_list "$@" |
587 while read mode sha1 stage sm_path
589 die_if_unmatched "$mode"
590 name=$(module_name "$sm_path") || exit
592 displaypath=$(relative_path "$sm_path")
594 # Copy url setting when it is not set yet
595 if test -z "$(git config "submodule.$name.url")"
596 then
597 url=$(git config -f .gitmodules submodule."$name".url)
598 test -z "$url" &&
599 die "$(eval_gettext "No url found for submodule path '\$displaypath' in .gitmodules")"
601 # Possibly a url relative to parent
602 case "$url" in
603 ./*|../*)
604 url=$(resolve_relative_url "$url") || exit
606 esac
607 git config submodule."$name".url "$url" ||
608 die "$(eval_gettext "Failed to register url for submodule path '\$displaypath'")"
610 say "$(eval_gettext "Submodule '\$name' (\$url) registered for path '\$displaypath'")"
613 # Copy "update" setting when it is not set yet
614 upd="$(git config -f .gitmodules submodule."$name".update)"
615 test -z "$upd" ||
616 test -n "$(git config submodule."$name".update)" ||
617 git config submodule."$name".update "$upd" ||
618 die "$(eval_gettext "Failed to register update mode for submodule path '\$displaypath'")"
619 done
623 # Unregister submodules from .git/config and remove their work tree
625 # $@ = requested paths (use '.' to deinit all submodules)
627 cmd_deinit()
629 # parse $args after "submodule ... deinit".
630 while test $# -ne 0
632 case "$1" in
633 -f|--force)
634 force=$1
636 -q|--quiet)
637 GIT_QUIET=1
640 shift
641 break
644 usage
647 break
649 esac
650 shift
651 done
653 if test $# = 0
654 then
655 die "$(eval_gettext "Use '.' if you really want to deinitialize all submodules")"
658 module_list "$@" |
659 while read mode sha1 stage sm_path
661 die_if_unmatched "$mode"
662 name=$(module_name "$sm_path") || exit
664 displaypath=$(relative_path "$sm_path")
666 # Remove the submodule work tree (unless the user already did it)
667 if test -d "$sm_path"
668 then
669 # Protect submodules containing a .git directory
670 if test -d "$sm_path/.git"
671 then
672 echo >&2 "$(eval_gettext "Submodule work tree '\$displaypath' contains a .git directory")"
673 die "$(eval_gettext "(use 'rm -rf' if you really want to remove it including all of its history)")"
676 if test -z "$force"
677 then
678 git rm -qn "$sm_path" ||
679 die "$(eval_gettext "Submodule work tree '\$displaypath' contains local modifications; use '-f' to discard them")"
681 rm -rf "$sm_path" &&
682 say "$(eval_gettext "Cleared directory '\$displaypath'")" ||
683 say "$(eval_gettext "Could not remove submodule work tree '\$displaypath'")"
686 mkdir "$sm_path" || say "$(eval_gettext "Could not create empty submodule directory '\$displaypath'")"
688 # Remove the .git/config entries (unless the user already did it)
689 if test -n "$(git config --get-regexp submodule."$name\.")"
690 then
691 # Remove the whole section so we have a clean state when
692 # the user later decides to init this submodule again
693 url=$(git config submodule."$name".url)
694 git config --remove-section submodule."$name" 2>/dev/null &&
695 say "$(eval_gettext "Submodule '\$name' (\$url) unregistered for path '\$displaypath'")"
697 done
701 # Update each submodule path to correct revision, using clone and checkout as needed
703 # $@ = requested paths (default to all)
705 cmd_update()
707 # parse $args after "submodule ... update".
708 orig_flags=
709 while test $# -ne 0
711 case "$1" in
712 -q|--quiet)
713 GIT_QUIET=1
715 -i|--init)
716 init=1
718 --remote)
719 remote=1
721 -N|--no-fetch)
722 nofetch=1
724 -f|--force)
725 force=$1
727 -r|--rebase)
728 update="rebase"
730 --reference)
731 case "$2" in '') usage ;; esac
732 reference="--reference=$2"
733 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
734 shift
736 --reference=*)
737 reference="$1"
739 -m|--merge)
740 update="merge"
742 --recursive)
743 recursive=1
745 --checkout)
746 update="checkout"
748 --depth)
749 case "$2" in '') usage ;; esac
750 depth="--depth=$2"
751 shift
753 --depth=*)
754 depth=$1
757 shift
758 break
761 usage
764 break
766 esac
767 orig_flags="$orig_flags $(git rev-parse --sq-quote "$1")"
768 shift
769 done
771 if test -n "$init"
772 then
773 cmd_init "--" "$@" || return
776 cloned_modules=
777 module_list "$@" | {
778 err=
779 while read mode sha1 stage sm_path
781 die_if_unmatched "$mode"
782 if test "$stage" = U
783 then
784 echo >&2 "Skipping unmerged submodule $prefix$sm_path"
785 continue
787 name=$(module_name "$sm_path") || exit
788 url=$(git config submodule."$name".url)
789 branch=$(get_submodule_config "$name" branch master)
790 if ! test -z "$update"
791 then
792 update_module=$update
793 else
794 update_module=$(git config submodule."$name".update)
797 displaypath=$(relative_path "$prefix$sm_path")
799 if test "$update_module" = "none"
800 then
801 echo "Skipping submodule '$displaypath'"
802 continue
805 if test -z "$url"
806 then
807 # Only mention uninitialized submodules when its
808 # path have been specified
809 test "$#" != "0" &&
810 say "$(eval_gettext "Submodule path '\$displaypath' not initialized
811 Maybe you want to use 'update --init'?")"
812 continue
815 if ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
816 then
817 module_clone "$sm_path" "$name" "$url" "$reference" "$depth" || exit
818 cloned_modules="$cloned_modules;$name"
819 subsha1=
820 else
821 subsha1=$(clear_local_git_env; cd "$sm_path" &&
822 git rev-parse --verify HEAD) ||
823 die "$(eval_gettext "Unable to find current revision in submodule path '\$displaypath'")"
826 if test -n "$remote"
827 then
828 if test -z "$nofetch"
829 then
830 # Fetch remote before determining tracking $sha1
831 (clear_local_git_env; cd "$sm_path" && git-fetch) ||
832 die "$(eval_gettext "Unable to fetch in submodule path '\$sm_path'")"
834 remote_name=$(clear_local_git_env; cd "$sm_path" && get_default_remote)
835 sha1=$(clear_local_git_env; cd "$sm_path" &&
836 git rev-parse --verify "${remote_name}/${branch}") ||
837 die "$(eval_gettext "Unable to find current ${remote_name}/${branch} revision in submodule path '\$sm_path'")"
840 if test "$subsha1" != "$sha1" -o -n "$force"
841 then
842 subforce=$force
843 # If we don't already have a -f flag and the submodule has never been checked out
844 if test -z "$subsha1" -a -z "$force"
845 then
846 subforce="-f"
849 if test -z "$nofetch"
850 then
851 # Run fetch only if $sha1 isn't present or it
852 # is not reachable from a ref.
853 (clear_local_git_env; cd "$sm_path" &&
854 ( (rev=$(git rev-list -n 1 $sha1 --not --all 2>/dev/null) &&
855 test -z "$rev") || git-fetch)) ||
856 die "$(eval_gettext "Unable to fetch in submodule path '\$displaypath'")"
859 # Is this something we just cloned?
860 case ";$cloned_modules;" in
861 *";$name;"*)
862 # then there is no local change to integrate
863 update_module= ;;
864 esac
866 must_die_on_failure=
867 case "$update_module" in
868 rebase)
869 command="git rebase"
870 die_msg="$(eval_gettext "Unable to rebase '\$sha1' in submodule path '\$displaypath'")"
871 say_msg="$(eval_gettext "Submodule path '\$displaypath': rebased into '\$sha1'")"
872 must_die_on_failure=yes
874 merge)
875 command="git merge"
876 die_msg="$(eval_gettext "Unable to merge '\$sha1' in submodule path '\$displaypath'")"
877 say_msg="$(eval_gettext "Submodule path '\$displaypath': merged in '\$sha1'")"
878 must_die_on_failure=yes
881 command="${update_module#!}"
882 die_msg="$(eval_gettext "Execution of '\$command \$sha1' failed in submodule path '\$prefix\$sm_path'")"
883 say_msg="$(eval_gettext "Submodule path '\$prefix\$sm_path': '\$command \$sha1'")"
884 must_die_on_failure=yes
887 command="git checkout $subforce -q"
888 die_msg="$(eval_gettext "Unable to checkout '\$sha1' in submodule path '\$displaypath'")"
889 say_msg="$(eval_gettext "Submodule path '\$displaypath': checked out '\$sha1'")"
891 esac
893 if (clear_local_git_env; cd "$sm_path" && $command "$sha1")
894 then
895 say "$say_msg"
896 elif test -n "$must_die_on_failure"
897 then
898 die_with_status 2 "$die_msg"
899 else
900 err="${err};$die_msg"
901 continue
905 if test -n "$recursive"
906 then
908 prefix="$prefix$sm_path/"
909 clear_local_git_env
910 cd "$sm_path" &&
911 eval cmd_update "$orig_flags"
913 res=$?
914 if test $res -gt 0
915 then
916 die_msg="$(eval_gettext "Failed to recurse into submodule path '\$displaypath'")"
917 if test $res -eq 1
918 then
919 err="${err};$die_msg"
920 continue
921 else
922 die_with_status $res "$die_msg"
926 done
928 if test -n "$err"
929 then
930 OIFS=$IFS
931 IFS=';'
932 for e in $err
934 if test -n "$e"
935 then
936 echo >&2 "$e"
938 done
939 IFS=$OIFS
940 exit 1
945 set_name_rev () {
946 revname=$( (
947 clear_local_git_env
948 cd "$1" && {
949 git describe "$2" 2>/dev/null ||
950 git describe --tags "$2" 2>/dev/null ||
951 git describe --contains "$2" 2>/dev/null ||
952 git describe --all --always "$2"
955 test -z "$revname" || revname=" ($revname)"
958 # Show commit summary for submodules in index or working tree
960 # If '--cached' is given, show summary between index and given commit,
961 # or between working tree and given commit
963 # $@ = [commit (default 'HEAD'),] requested paths (default all)
965 cmd_summary() {
966 summary_limit=-1
967 for_status=
968 diff_cmd=diff-index
970 # parse $args after "submodule ... summary".
971 while test $# -ne 0
973 case "$1" in
974 --cached)
975 cached="$1"
977 --files)
978 files="$1"
980 --for-status)
981 for_status="$1"
983 -n|--summary-limit)
984 summary_limit="$2"
985 isnumber "$summary_limit" || usage
986 shift
988 --summary-limit=*)
989 summary_limit="${1#--summary-limit=}"
990 isnumber "$summary_limit" || usage
993 shift
994 break
997 usage
1000 break
1002 esac
1003 shift
1004 done
1006 test $summary_limit = 0 && return
1008 if rev=$(git rev-parse -q --verify --default HEAD ${1+"$1"})
1009 then
1010 head=$rev
1011 test $# = 0 || shift
1012 elif test -z "$1" -o "$1" = "HEAD"
1013 then
1014 # before the first commit: compare with an empty tree
1015 head=$(git hash-object -w -t tree --stdin </dev/null)
1016 test -z "$1" || shift
1017 else
1018 head="HEAD"
1021 if [ -n "$files" ]
1022 then
1023 test -n "$cached" &&
1024 die "$(gettext "The --cached option cannot be used with the --files option")"
1025 diff_cmd=diff-files
1026 head=
1029 cd_to_toplevel
1030 eval "set $(git rev-parse --sq --prefix "$wt_prefix" -- "$@")"
1031 # Get modified modules cared by user
1032 modules=$(git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- "$@" |
1033 sane_egrep '^:([0-7]* )?160000' |
1034 while read mod_src mod_dst sha1_src sha1_dst status sm_path
1036 # Always show modules deleted or type-changed (blob<->module)
1037 test $status = D -o $status = T && echo "$sm_path" && continue
1038 # Respect the ignore setting for --for-status.
1039 if test -n "$for_status"
1040 then
1041 name=$(module_name "$sm_path")
1042 ignore_config=$(get_submodule_config "$name" ignore none)
1043 test $status != A -a $ignore_config = all && continue
1045 # Also show added or modified modules which are checked out
1046 GIT_DIR="$sm_path/.git" git-rev-parse --git-dir >/dev/null 2>&1 &&
1047 echo "$sm_path"
1048 done
1051 test -z "$modules" && return
1053 git $diff_cmd $cached --ignore-submodules=dirty --raw $head -- $modules |
1054 sane_egrep '^:([0-7]* )?160000' |
1055 cut -c2- |
1056 while read mod_src mod_dst sha1_src sha1_dst status name
1058 if test -z "$cached" &&
1059 test $sha1_dst = 0000000000000000000000000000000000000000
1060 then
1061 case "$mod_dst" in
1062 160000)
1063 sha1_dst=$(GIT_DIR="$name/.git" git rev-parse HEAD)
1065 100644 | 100755 | 120000)
1066 sha1_dst=$(git hash-object $name)
1068 000000)
1069 ;; # removed
1071 # unexpected type
1072 eval_gettextln "unexpected mode \$mod_dst" >&2
1073 continue ;;
1074 esac
1076 missing_src=
1077 missing_dst=
1079 test $mod_src = 160000 &&
1080 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_src^0 >/dev/null &&
1081 missing_src=t
1083 test $mod_dst = 160000 &&
1084 ! GIT_DIR="$name/.git" git-rev-parse -q --verify $sha1_dst^0 >/dev/null &&
1085 missing_dst=t
1087 display_name=$(relative_path "$name")
1089 total_commits=
1090 case "$missing_src,$missing_dst" in
1092 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_src")"
1095 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commit \$sha1_dst")"
1097 t,t)
1098 errmsg="$(eval_gettext " Warn: \$display_name doesn't contain commits \$sha1_src and \$sha1_dst")"
1101 errmsg=
1102 total_commits=$(
1103 if test $mod_src = 160000 -a $mod_dst = 160000
1104 then
1105 range="$sha1_src...$sha1_dst"
1106 elif test $mod_src = 160000
1107 then
1108 range=$sha1_src
1109 else
1110 range=$sha1_dst
1112 GIT_DIR="$name/.git" \
1113 git rev-list --first-parent $range -- | wc -l
1115 total_commits=" ($(($total_commits + 0)))"
1117 esac
1119 sha1_abbr_src=$(echo $sha1_src | cut -c1-7)
1120 sha1_abbr_dst=$(echo $sha1_dst | cut -c1-7)
1121 if test $status = T
1122 then
1123 blob="$(gettext "blob")"
1124 submodule="$(gettext "submodule")"
1125 if test $mod_dst = 160000
1126 then
1127 echo "* $display_name $sha1_abbr_src($blob)->$sha1_abbr_dst($submodule)$total_commits:"
1128 else
1129 echo "* $display_name $sha1_abbr_src($submodule)->$sha1_abbr_dst($blob)$total_commits:"
1131 else
1132 echo "* $display_name $sha1_abbr_src...$sha1_abbr_dst$total_commits:"
1134 if test -n "$errmsg"
1135 then
1136 # Don't give error msg for modification whose dst is not submodule
1137 # i.e. deleted or changed to blob
1138 test $mod_dst = 160000 && echo "$errmsg"
1139 else
1140 if test $mod_src = 160000 -a $mod_dst = 160000
1141 then
1142 limit=
1143 test $summary_limit -gt 0 && limit="-$summary_limit"
1144 GIT_DIR="$name/.git" \
1145 git log $limit --pretty='format: %m %s' \
1146 --first-parent $sha1_src...$sha1_dst
1147 elif test $mod_dst = 160000
1148 then
1149 GIT_DIR="$name/.git" \
1150 git log --pretty='format: > %s' -1 $sha1_dst
1151 else
1152 GIT_DIR="$name/.git" \
1153 git log --pretty='format: < %s' -1 $sha1_src
1155 echo
1157 echo
1158 done
1161 # List all submodules, prefixed with:
1162 # - submodule not initialized
1163 # + different revision checked out
1165 # If --cached was specified the revision in the index will be printed
1166 # instead of the currently checked out revision.
1168 # $@ = requested paths (default to all)
1170 cmd_status()
1172 # parse $args after "submodule ... status".
1173 while test $# -ne 0
1175 case "$1" in
1176 -q|--quiet)
1177 GIT_QUIET=1
1179 --cached)
1180 cached=1
1182 --recursive)
1183 recursive=1
1186 shift
1187 break
1190 usage
1193 break
1195 esac
1196 shift
1197 done
1199 module_list "$@" |
1200 while read mode sha1 stage sm_path
1202 die_if_unmatched "$mode"
1203 name=$(module_name "$sm_path") || exit
1204 url=$(git config submodule."$name".url)
1205 displaypath=$(relative_path "$prefix$sm_path")
1206 if test "$stage" = U
1207 then
1208 say "U$sha1 $displaypath"
1209 continue
1211 if test -z "$url" || ! test -d "$sm_path"/.git -o -f "$sm_path"/.git
1212 then
1213 say "-$sha1 $displaypath"
1214 continue;
1216 if git diff-files --ignore-submodules=dirty --quiet -- "$sm_path"
1217 then
1218 set_name_rev "$sm_path" "$sha1"
1219 say " $sha1 $displaypath$revname"
1220 else
1221 if test -z "$cached"
1222 then
1223 sha1=$(clear_local_git_env; cd "$sm_path" && git rev-parse --verify HEAD)
1225 set_name_rev "$sm_path" "$sha1"
1226 say "+$sha1 $displaypath$revname"
1229 if test -n "$recursive"
1230 then
1232 prefix="$displaypath/"
1233 clear_local_git_env
1234 cd "$sm_path" &&
1235 eval cmd_status
1236 ) ||
1237 die "$(eval_gettext "Failed to recurse into submodule path '\$sm_path'")"
1239 done
1242 # Sync remote urls for submodules
1243 # This makes the value for remote.$remote.url match the value
1244 # specified in .gitmodules.
1246 cmd_sync()
1248 while test $# -ne 0
1250 case "$1" in
1251 -q|--quiet)
1252 GIT_QUIET=1
1253 shift
1255 --recursive)
1256 recursive=1
1257 shift
1260 shift
1261 break
1264 usage
1267 break
1269 esac
1270 done
1271 cd_to_toplevel
1272 module_list "$@" |
1273 while read mode sha1 stage sm_path
1275 die_if_unmatched "$mode"
1276 name=$(module_name "$sm_path")
1277 url=$(git config -f .gitmodules --get submodule."$name".url)
1279 # Possibly a url relative to parent
1280 case "$url" in
1281 ./*|../*)
1282 # rewrite foo/bar as ../.. to find path from
1283 # submodule work tree to superproject work tree
1284 up_path="$(echo "$sm_path" | sed "s/[^/][^/]*/../g")" &&
1285 # guarantee a trailing /
1286 up_path=${up_path%/}/ &&
1287 # path from submodule work tree to submodule origin repo
1288 sub_origin_url=$(resolve_relative_url "$url" "$up_path") &&
1289 # path from superproject work tree to submodule origin repo
1290 super_config_url=$(resolve_relative_url "$url") || exit
1293 sub_origin_url="$url"
1294 super_config_url="$url"
1296 esac
1298 if git config "submodule.$name.url" >/dev/null 2>/dev/null
1299 then
1300 displaypath=$(relative_path "$prefix$sm_path")
1301 say "$(eval_gettext "Synchronizing submodule url for '\$displaypath'")"
1302 git config submodule."$name".url "$super_config_url"
1304 if test -e "$sm_path"/.git
1305 then
1307 clear_local_git_env
1308 cd "$sm_path"
1309 remote=$(get_default_remote)
1310 git config remote."$remote".url "$sub_origin_url"
1312 if test -n "$recursive"
1313 then
1314 prefix="$prefix$sm_path/"
1315 eval cmd_sync
1320 done
1323 # This loop parses the command line arguments to find the
1324 # subcommand name to dispatch. Parsing of the subcommand specific
1325 # options are primarily done by the subcommand implementations.
1326 # Subcommand specific options such as --branch and --cached are
1327 # parsed here as well, for backward compatibility.
1329 while test $# != 0 && test -z "$command"
1331 case "$1" in
1332 add | foreach | init | deinit | update | status | summary | sync)
1333 command=$1
1335 -q|--quiet)
1336 GIT_QUIET=1
1338 -b|--branch)
1339 case "$2" in
1341 usage
1343 esac
1344 branch="$2"; shift
1346 --cached)
1347 cached="$1"
1350 break
1353 usage
1356 break
1358 esac
1359 shift
1360 done
1362 # No command word defaults to "status"
1363 if test -z "$command"
1364 then
1365 if test $# = 0
1366 then
1367 command=status
1368 else
1369 usage
1373 # "-b branch" is accepted only by "add"
1374 if test -n "$branch" && test "$command" != add
1375 then
1376 usage
1379 # "--cached" is accepted only by "status" and "summary"
1380 if test -n "$cached" && test "$command" != status -a "$command" != summary
1381 then
1382 usage
1385 "cmd_$command" "$@"